/******************************************************************************
 *
 *	PalmKart mini
 *	ver 1.3.3
 *	2008.11 / 2009.5
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <SonyCLIE.h>
#include "defrsc.h"

//#define DEBUG
//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
void count_down( void );
void disp_signal( void );
void move_kart( void );
void draw_course_chr( UInt32 , UInt32 , WinHandle );
void init_kart( void );
void init_bg( void );
void draw_marker( void );
void erase_marker( void );
void draw_ghost_marker( void );
void erase_ghost_marker( void );
void animetion( void );
Boolean is_bound_block( Int32, Int32 );
void init_goal( void );
void init_lap( void );
void count_lap( void );
void check_lap( void );
void disp_lap( void );
//void check_reverse( void );
void show_record( int, UInt32, Coord, Coord );
void check_goal( void );
void init_rec_wait( void );
void init_demo( void );
void init_ghost( void );
void demo( void );
void record_lap_time( void );
void record_ghost( void );
void draw_ghost( void );
void erase_ghost( void );
void fall_kart( void );
void restart_kart( void );
void rotate_kart( void );
void print_mode( void );
void set_owata( void );
void print_engine( void );
void print_record_time( void );
void set_spin( void );
void operate_steer( void );
void set_drift_long( void );
void set_drift_short( void );
void set_mud( void );
void spin_mud( void );
void draw_mud_chr( UInt32 , UInt32, WinHandle );



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/
extern int sin_tbl[];
extern int cos_tbl[];


// R[Xf[^

// R[XWvZpe[u
static IndexedColorType *course_y_p[ COURSE_HEIGHT ];

// X^[gʒu,
static int start_pos[][3] = {
  { 592, 304, 96 },
  { 432, 48, 64 },
  { 48, 128, 32 },
  { 208, 304, 64 },
  { 512, 432, 64 },
  { 512, 32, 64 },
  { 64, 240, 96 },
  { 288, 256, 64 },
  { 608, 336, 96 },
  { 272, 432, 64 } };

// R[XAEg̕`F
static UInt8  out[] = { 145, 73, 120, 89, 215, 145, 73, 120, 89, 215 };

static UInt32 pre_start_tick;
static int indicator_wait;



/************************************************
 *	GW
 ***********************************************/
void
init_engine( void )
{
  Engine.cc = MODE_50CC; // 50cc
}



/************************************************
 *	GW؂ւ
 ***********************************************/
void
change_engine( void )
{
  static int engine_data[][3] = {
    { MAX_SPEED_50, MIDDLE_SPEED_50, TURBO_SPEED_50 },
    { MAX_SPEED_100, MIDDLE_SPEED_100, TURBO_SPEED_100 },
    { MAX_SPEED_150, MIDDLE_SPEED_150, TURBO_SPEED_150 },
  };


  Engine.max_speed = engine_data[ Engine.cc ][0];
  Engine.middle_speed = engine_data[ Engine.cc ][1];
  Engine.turbo_speed = engine_data[ Engine.cc ][2];
}



/************************************************
 *	R[XZNg
 ***********************************************/
void
select_course( void )
{
  if( Key.keep & Keyset.left )
    {
      Course.no--;
      if( Course.no < 0 ) Course.no = (COURSE_MAX-1);
      set_se( click );

      init_course();
    }
  else if( Key.keep & Keyset.right )
    {
      Course.no++;
      if( Course.no > (COURSE_MAX-1) ) Course.no = 0;
      set_se( click );

      init_course();
    }
  else if( Key.keep & Keyset.up )
    {
      Ghost.on[ Course.no ] ^= 1;
    }

  draw_course_map();
  print_course_name();
  print_ghost_on();

  clear_status();

  print_mode();
  print_engine();
  print_record_time();
}



/************************************************
 *	X^[gJEg_E
 ***********************************************/
void
pre_start( void )
{
  if( ! Demo.end )
    demo();

  if( Demo.end )
    count_down();
}



/************************************************
 *	ѕ\
 ***********************************************/
void
disp_total_record( void )
{
  clear_view();

  if( --Rec_wait.lap1 < 0 )
    show_record( 1, Lap.time[0]+Lap.time[1], 75, 30 );
  if( --Rec_wait.lap2 < 0 )
    show_record( 2, Lap.time[2], 75, 40 );
  if( --Rec_wait.lap3 < 0 )
    show_record( 3, Lap.time[3], 75, 50 );
  if( --Rec_wait.lap4 < 0 )
    show_record( 4, Lap.time[4], 75, 60 );
  if( --Rec_wait.lap5 < 0 )
    show_record( 5, Lap.time[5], 75, 70 );
  if( --Rec_wait.lap6 < 0 )
    show_record( -1, Lap.total, 75, 81 );
}



/************************************************
 *	Q[̏
 ***********************************************/
void
init_game( void )
{
  init_kart();
  init_goal();
  init_lap();
  init_rec_wait();
  init_bg();
  init_ghost();
  clear_status();
  draw_bg();
//  draw_course_map();

  draw_ghost_marker();
  draw_marker();

//  draw_3d_view();
//  draw_kart();
  show_status();
  init_demo();

  pre_start_tick = 0;		// JEg_E
  Count.c1 = Count.c2 = false;	// JEg_EptO

  Dash.on = true;		// PbgX^[g

  Lap.tick = TimGetTicks() / 10;
  count_lap();
}



/************************************************
 *	Q[̃C
 ***********************************************/
void
play_game( void )
{
  if( ! Game.active ) return;
  if( TimGetTicks() < Timer.interval + Timer.frame_tick ) return;

  // TickXV
  Timer.interval = TimGetTicks();

  get_hard_key();		// n[hL[擾
  animetion();
  if( !select_game_event() )	// eQ[pCxg
    {
      erase_marker();
      erase_ghost_marker();

      move_kart();
      spin_mud();

      draw_ghost();
      draw_3d_view();		// [3D\
      erase_ghost();

      fall_kart();
      restart_kart();
      draw_kart();
      draw_bg();

      draw_ghost_marker();
      draw_marker();

      disp_signal();
      count_lap();
      record_ghost();
      check_lap();
      check_goal();
    }
  melody();			// BGM SE
  change_se();
  disp_se();
  copy_buff_to_lcd();		// obNXN[LCDɃRs[
}



//////////////////////////////////////////////////////////////////////////////



/************************************************
 *	S[Xg̏
 ***********************************************/
static void
init_ghost( void )
{
  int i;
  GhostRecType *rec = Ghost.work_p;


  for( i = 0; i < GHOST_MAX; i++ )
    {
      rec[i].x = rec[i].y = -1;
    }

  rec[0].x = Kart.x >> FIXBIT;
  rec[0].y = Kart.y >> FIXBIT;
  rec[0].rad = Camera.rad;

  Ghost.frame = 0;
}



/************************************************
 *	S[Xg̋L^
 ***********************************************/
static void
record_ghost( void )
{
  GhostRecType *rec = Ghost.work_p;


  if( Ghost.frame < GHOST_MAX-1 )
    {
      rec[ Ghost.frame ].x = Kart.x >> FIXBIT;
      rec[ Ghost.frame ].y = Kart.y >> FIXBIT;
      rec[ Ghost.frame ].rad = Camera.rad;

      Ghost.frame++;
    }
}



/************************************************
 *	S[Xg`
 ***********************************************/
static void
draw_ghost( void )
{
  int i;
  Coord x, y;
  GhostRecType *read = Ghost.read_p[ Course.no ];
  UInt8 *screen;
  UInt8 *chr = BmpGetBits( WinGetBitmap( Bmp.handle[ BMP_GHOST1 + (Anime.counter & 1) ] ) );


  if( ! Ghost.on[ Course.no ] || Engine.cc != MODE_100CC ) return;

  x = read[ Ghost.frame ].x;
  y = read[ Ghost.frame ].y;
  if( x == -1 ) return;

//  x -= 2; y -= 2;
  if( (UInt16)x >= (COURSE_WIDTH-GHOST_SIZE_X) || (UInt16)y >= (COURSE_HEIGHT-GHOST_SIZE_Y) ) return;

  screen = course_y_p[ y ] + x;

  for( i = 0; i < GHOST_SIZE_Y; i++ )
    {
      Ghost.save[i][0] = *screen;
      *screen++ = *chr++;
      Ghost.save[i][1] = *screen;
      *screen++ = *chr++;
      Ghost.save[i][2] = *screen;
      *screen++ = *chr++;
      Ghost.save[i][3] = *screen;
      *screen++ = *chr++;
      Ghost.save[i][4] = *screen;
      *screen++ = *chr++;
      Ghost.save[i][5] = *screen;
      *screen++ = *chr++;
      Ghost.save[i][6] = *screen;
      *screen++ = *chr++;
      Ghost.save[i][7] = *screen;
      *screen++ = *chr++;

      screen += COURSE_WIDTH-GHOST_SIZE_X;
    }
}



/************************************************
 *	S[Xg
 ***********************************************/
static void
erase_ghost( void )
{
  int i;
  Coord x, y;
  GhostRecType *read = Ghost.read_p[ Course.no ];
  UInt8 *screen;


  if( ! Ghost.on[ Course.no ] || Engine.cc != MODE_100CC ) return;

  x = read[ Ghost.frame ].x;
  y = read[ Ghost.frame ].y;
  if( x == -1 ) return;

//  x -= 2; y -= 2;
  if( (UInt16)x >= (COURSE_WIDTH-GHOST_SIZE_X) || (UInt16)y >= (COURSE_HEIGHT-GHOST_SIZE_Y) ) return;

  screen = course_y_p[ y ] + x;

  for( i = 0; i < GHOST_SIZE_Y; i++ )
    {
      *screen++ = Ghost.save[i][0];
      *screen++ = Ghost.save[i][1];
      *screen++ = Ghost.save[i][2];
      *screen++ = Ghost.save[i][3];
      *screen++ = Ghost.save[i][4];
      *screen++ = Ghost.save[i][5];
      *screen++ = Ghost.save[i][6];
      *screen++ = Ghost.save[i][7];

      screen += COURSE_WIDTH-GHOST_SIZE_X;
    }
}



/************************************************
 *	X^[g̃Aj
 ***********************************************/
static void
demo( void )
{
  Demo.rad = (Demo.rad + 2) & RAD_MAX;

  Camera.rad = Demo.rad;
  draw_bg();
  draw_3d_view();

  if( ! (--Demo.chr_count) )
    {
      Demo.chr++;
      Demo.chr_count = DEMO_CHR_COUNT;
    }

  sprite( SHIP_X-3, SHIP_Y, Demo.chr );


  if( --Demo.ind_count < 0 )
    sprite( 64, Demo.ind_y++, BMP_PRE1 );

  if( Demo.rad == start_pos[ Course.no ][2] )
    Demo.end = true;
}



/************************************************
 *	X^[g̃Aj
 ***********************************************/
static void
init_demo( void )
{
  Demo.rad = ( start_pos[ Course.no ][2] - 64 ) & RAD_MAX;
  Demo.end = false;
  Demo.ind_count = 64/2 -14;
  Demo.ind_y = 28 -13;
  Demo.chr = BMP_INC;
  Demo.chr_count = DEMO_CHR_COUNT;
}



/************************************************
 *	R[h\EFCg
 ***********************************************/
static void
init_rec_wait( void )
{
  Rec_wait.lap1 = 5;
  Rec_wait.lap2 = 10;
  Rec_wait.lap3 = 15;
  Rec_wait.lap4 = 20;
  Rec_wait.lap5 = 25;
  Rec_wait.lap6 = 30;
}



/************************************************
 *	g[^bv\
 ***********************************************/
static void
show_record( int lap, UInt32 time, Coord x, Coord y )
{
  UInt32 num;


  if( lap != -1 )
    {
      sprite( x-48, y, BMP_LAP );
      show_num( x-20, y, lap, 1 );
    }
  else
    {
      sprite( x-57, y, BMP_TOTAL );
    }

  num = time;
  show_num( x + 43, y, num, 1 );

  // ''
  sprite( x+36, y, BMP_SEP2 );

  num = time / 10;
  num %= 60;
  show_num( x + 20, y, num, 2 );

  // '
  sprite( x+14, y, BMP_SEP1 );

  num = time / 600;
  num %= 60;
  show_num( x, y, num, 2 );

  show_num( x + 51, y, 0, 1 );
}



/************************************************
 *	S[
 ***********************************************/
static void
check_goal( void )
{
  static int wait = 0;
  GhostRecType *rec = Ghost.work_p;


  if( ! Goal.goal ) return;

  if( ! (Anime.counter & 3) ) wait ^= 1;

  if( wait )
    sprite( 25, 26, BMP_GOAL ); // S[

  // J荞
  if( Camera.rad != Demo.rad )
    {
      Camera.rad = (Camera.rad + 2) & RAD_MAX;

      if( ! (--Demo.chr_count) )
        {
          Demo.chr++;
          Demo.chr_count = DEMO_CHR_COUNT;
        }
    }
  sprite( SHIP_X-3, SHIP_Y, Demo.chr );

  if( --Goal.frame_wait < 0 )
    {
      Game.state = GAME_FINISH;
    }
}



/************************************************
 *	bv
 ***********************************************/
static void
init_lap( void )
{
  int i;


  Lap.count = 0;
  for( i = 0; i < LAP_MAX +1; i++ )
    {
      Lap.time[i] = 0;
    }
}



/************************************************
 *	S[
 ***********************************************/
static void
init_goal( void )
{
  CheckGoal.through = false;
  CheckGoal.reverse = 0;

  Goal.goal = false;
  Goal.frame_wait = GOAL_WAIT;
}



/************************************************
 *	^CJEg
 ***********************************************/
static void
count_lap( void )
{
  UInt32 count, num;


  if( Goal.goal ) return;

  count = TimGetTicks() / 10 - Lap.tick;

  //  b ~b 5\
  num = count;
  show_num( 118, 2, num, 1 );

  num = count / 10;
  num %= 60;
  show_num( 95, 2, num, 2 );

  num = count / 600;
  num %= 60;
  show_num( 75, 2, num, 2 );
}



/************************************************
 *	`FbN
 ***********************************************/
static void
check_lap( void )
{
  static int direc[] = { // px
    65, 127,
    33, 95,
    1, 63,
    33, 95,
    33, 95,
    33, 95,
    65, 127,
    33, 95,
    65, 127,
    33, 95, };
  static RectangleType rect[] = { // `FbN|Cg`
    { 528, 272, 96, 16 },
    { 400, 16, 16, 80 },
    { 16, 144, 80, 16 },
    { 176, 288, 16, 48 },
    { 480, 416, 16, 48 },
    { 480, 16, 16, 80 },
    { 32, 208, 64, 16 },
    { 256, 224, 16, 64 },
    { 576, 304, 48, 16 },
    { 240, 416, 16, 48 } };
  Coord x, y;
  int rad_min = direc[ Course.no * 2 ];
  int rad_max = direc[ Course.no * 2 + 1 ];


  if( Goal.goal ) return;

  x = Kart.x >> FIXBIT;
  y = Kart.y >> FIXBIT;

  if( (UInt16) x - rect[ Course.no ].topLeft.x < (UInt16) rect[ Course.no ].extent.x
      && (UInt16) y - rect[ Course.no ].topLeft.y < (UInt16) rect[ Course.no ].extent.y )
    {
      if( ! CheckGoal.through )
        {
          CheckGoal.through = true;
          if( Kart.rad <= rad_max && Kart.rad >= rad_min ) // 
            {
              if( ! CheckGoal.reverse )
                {
                  record_lap_time();	// R[h^C
                  Lap.count++;		// JE^0 ʉ߂ bv +1
                  if( Lap.count == GOAL_LAP )
                    {
                      Goal.goal = true; // I
                      Lap.total = Lap.time[0] + Lap.time[1] + Lap.time[2] + Lap.time[3] + Lap.time[4] + Lap.time[5];

                      Demo.rad = (Camera.rad + 64) & RAD_MAX;
                      Demo.chr = BMP_INC + 2;
                      Demo.chr_count = DEMO_CHR_COUNT;

                      set_se( goal );
                    }
                  else
                    {
                      show_num( 28, 2, Lap.count, 1 );
                      set_se( lap );
                    }
                }
              else
                {
                  CheckGoal.reverse++;	// JE^0 ȊOŒʉ
                }
            }
          else
            {
              CheckGoal.reverse--;		 // t
            }
        }
    }
  else
    {
      CheckGoal.through = false;
    }
}



/************************************************
 *	bv^CL^
 ***********************************************/
static void
record_lap_time( void )
{
  int i;
  UInt32 time;


  time = TimGetTicks() / 10 - Lap.tick;
  Lap.time[ Lap.count ] = time;

  if( ! Lap.count ) return;

  for( i = Lap.count; i > 0; i-- )
    {
      time -= Lap.time[i-1];
    }
  Lap.time[ Lap.count ] = time;
}



/************************************************
 *	JEg_E
 ***********************************************/
static void
count_down( void )
{
  UInt32 tick;


  if( ! pre_start_tick )
    {
      sprite( 64, 28, BMP_PRE1 ); // 3
      pre_start_tick = TimGetTicks();
    }

  tick = TimGetTicks() - pre_start_tick;

  if( tick >= 300 )
    {
      sprite( 64, 28, BMP_PRE4 ); // 0
      set_se( countdown2 );

      indicator_wait = SEC;			// X^[g낢
      Game.state = GAME_START;
      Ghost.frame++;

      Lap.tick = TimGetTicks() / 10; // JEgJn
    }
  else if( tick >= (300-START_DASH) )
    {
      if( Key.single & Keyset.acc && Dash.on ) // PbgX^[g
        {
          Kart.speed = Kart.max_speed;
        }
    }
  else if( tick >= 200 )
    {
      sprite( 64, 28, BMP_PRE3 ); // 1
      if( !Count.c1 )
        {
          set_se( countdown1 );
          Count.c1 = true;
        }
      if( Key.single & Keyset.acc )
        Dash.on = false;
    }
  else if( tick >= 100 )
    {
      sprite( 64, 28, BMP_PRE2 ); // 2
      if( !Count.c2 )
        {
          set_se( countdown1 );
          Count.c2 = true;
        }
    }
}



/************************************************
 *	VOi\
 ***********************************************/
static void
disp_signal( void )
{
  if( indicator_wait )
    {
      sprite( 64, 28, BMP_PRE4 );
      indicator_wait--;
    }
}



/************************************************
 *	AjpJE^
 ***********************************************/
static void
animetion( void )
{
  if( ++Anime.counter == 65535 ) Anime.counter = 0;
}



/************************************************
 *	J[g̏
 ***********************************************/
static void
init_kart( void )
{
  Kart.x = start_pos[ Course.no ][0] * FIX;
  Kart.y = start_pos[ Course.no ][1] * FIX;
  Kart.rad = start_pos[ Course.no ][2];
  Camera.rad = Kart.rad; // Jݒ

  Kart.smoke = false;
  Kart.anime = false;
  Kart.fall = false;
  Kart.fall_frame = 0;
  Kart.fall_count = 0;
  Kart.crush = 0;

  Kart.speed = Kart.speed_acc = 0;
  Kart.max_speed = Engine.max_speed;
  Kart.chr = BMP_KART_NOMAL;

  Kart.steer = Kart.steer_full = 0;
  Kart.r_wait = Kart.l_wait = 0;

  Turbo.frame = Turbo.count = 0;

  Drift.on = Drift.jump = false;
  Drift.right = Drift.left = false;
  Drift.count = Drift.end = 0;
  Drift.short_speed = Drift.inatia_speed = Drift.inatia_speed_acc = 0;

  Spin.on = Drift.crush_check = false;
  Mud.frame = 0;

  Kart.shake_y = 0;
}



/************************************************
 *	J[g\
 ***********************************************/
void
draw_kart( void )
{
  Coord x, y;
  int anime = Anime.counter & 1;


  if( Goal.goal ) return;

  x = SHIP_X; y = SHIP_Y;
  if( anime && Kart.speed >= (MAX_SPEED_ACC*2) )
    {
      Kart.shake_y ^= 1;
      if( Kart.smoke || Mud.frame )
        {
          y -= Kart.shake_y;
          x += RND(3) -1;
        }
    }
  y -= Kart.shake_y;

  // 
  if( Kart.fall )
    {
      if( --Kart.speed < 0 ) Kart.speed = 0;
      sprite( x, y, BMP_FALL_KART + (3 -(Kart.speed / FALL_ANIME_DIV)) );
      return;
    }

  // m[}
  if( Kart.anime && ! Drift.on && ! Drift.jump && ! Drift.end && ! Spin.on )
    sprite( x, y, Kart.chr + anime );
  else if( ! Kart.anime && ! Drift.on && ! Drift.jump && ! Drift.end && ! Spin.on )
    sprite( x, y, Kart.chr );


  // eGtFNg
  // htg
  if( Drift.on && ! Drift.jump )
    {
      set_se( drift );
      if( Drift.left )
        {
          sprite( x, y, BMP_DRIFT_CHR_L );
          if( ! Mud.frame )
            sprite( x - 12 + RND(2), SMOKE_Y + RND(2), BMP_DRIFT_R );
        }
      else
        {
          sprite( x, y, BMP_DRIFT_CHR_R );
          if( ! Mud.frame )
            sprite( x + 18 + RND(2), SMOKE_Y + RND(2), BMP_DRIFT_L );
        }
    }
  // htg畜A
  if( Drift.end && ! Spin.on && ! Drift.jump )
    {
      if( Drift.left )
        {
          sprite( x, y, BMP_KART_L );
        }
      else
        {
          sprite( x, y, BMP_KART_R );
        }
    }

  // ō
  if( ! Drift.on && Drift.short_speed == MAX_DRIFT_SHORT_SPEED && ! Turbo.count && ! Spin.on && ! Mud.frame )
    {
      sprite( SMOKE_X + RND(4), SMOKE_Y + RND(4), BMP_MAX_SPEED );
    }

  // Wv
  if( Drift.jump )
    {
      y = SHIP_Y;
      sprite( x, y - 6, BMP_DRIFT_JUMP );
      if( ! (--Drift.jump_count) )
        Drift.jump = false;
    }

  // y
  if( Kart.smoke && Kart.speed && ! Drift.on && ! Drift.jump && ! Mud.frame )
    {
      set_se( rough );
      sprite( SMOKE_X + RND(2), SMOKE_Y + RND(2), BMP_SMOKE );
    }

  if( Key.single & Keyset.brake && Kart.speed > (MAX_SPEED_ACC*2) )
    {
      set_se( rough );
      sprite( SMOKE_X + RND(2), SMOKE_Y + RND(2), BMP_SMOKE );
    }

  // ^[{
  if( Turbo.count && ! Mud.frame )
    {
//      set_se( turbo );
      if( ! (--Turbo.count) )
        {
          Kart.max_speed = Engine.max_speed; // ^[{Zbg
          Turbo.frame = 0;
        }
      sprite( SMOKE_X + RND(4), SMOKE_Y + RND(4), BMP_TURBO );
    }

  // NbV
  if( Kart.crush )
    {
      if( --Kart.crush >= (CRUSH_FRAME / 2) )
        {
          x = SHIP_X-4; y = SHIP_Y-1;
          sprite( x, y, BMP_CRUSH );
        }
    }

  // Xs
  if( Spin.on )
    {
      Spin.frame--;
      if( ! Spin.frame )
        Spin.on = false;

      if( ! anime )
        Spin.anime = (Spin.anime + 1) & 3;
      sprite( x-3, y, BMP_SPIN + Spin.anime );
    }

  // DԂ
  if( Mud.frame )
    {
      set_se( rough );
      sprite( SMOKE_X + RND(2), SMOKE_Y + RND(2), BMP_MUD_SPRAY );
    }
}



/************************************************
 *	J[gړ
 ***********************************************/
static void
move_kart( void )
{
  UInt8 pixel;
  Coord x, y;
  int speed;
  Int32 add_x, add_y;
  // J[
  static int frc[] = { 176, 75, 155, 19, 1, 176, 75, 155, 19, 1 }; // 1̓_~[


  Kart.smoke = Kart.anime = false;
  Kart.chr = BMP_KART_NOMAL;

  x = Kart.x >> FIXBIT; y = Kart.y >> FIXBIT;

  pixel = 255;
  if( (UInt16) x < COURSE_WIDTH && (UInt16) y < COURSE_HEIGHT )
    {
      pixel = *( course_y_p[ y ] + x );
    }

  // 
  if( pixel == frc[ Course.no ] && !Turbo.count )
    {
      Kart.max_speed = Engine.middle_speed;
      Drift.short_speed = MAX_DRIFT_SHORT_SPEED/2;
      Kart.smoke = true;
    }
  else if( !Turbo.count )
    {
      Kart.max_speed = Engine.max_speed;
    }

  // ANZ
  if( Key.single & Keyset.acc && ! Goal.goal && ! Kart.fall && ! Kart.crush && ! Spin.on )
    {
      Kart.rad = Camera.rad;
      Kart.anime = true;

      if( Kart.speed_acc < 0 ) Kart.speed_acc = 0;

      Kart.speed_acc += ACC;
      if( Kart.speed_acc > MAX_SPEED_ACC )
        Kart.speed_acc = MAX_SPEED_ACC;

      if( Kart.speed < (MAX_SPEED_ACC *4) )
        Kart.smoke = true;
    }
  else
    {
      Turbo.frame = Turbo.count = 0;
      Kart.max_speed = Engine.max_speed; // ^[{Zbg
      Drift.on = Drift.jump = false;
      Drift.short_speed /= 2;
    }

  // u[L
  if( Key.single & Keyset.brake && ! Goal.goal && ! Kart.fall && ! Kart.crush && ! Spin.on )
    {
      Kart.speed_acc = -BRAKE_ACC;
    }

  // ~j^[{ JEg
  if( Drift.on  && ! Kart.crush  && ! Spin.on )
    Turbo.frame++;
  else
    Turbo.frame = 0;

  // XeAO
  operate_steer();

  // htg`FbN
  if( ! Drift.on && Drift.left || Drift.right )
    Drift.count++;

  // htg
  if( Drift.end )
    Drift.end--;

  //nhXibv
  if( Abs( Kart.steer_full - Kart.steer ) < 1 )
    Kart.steer = Kart.steer_full;
  else
    Kart.steer += ( Kart.steer_full - Kart.steer ) / STEER_SNAP;

  // 
  if( Kart.speed  && Kart.steer && ! Goal.goal && ! Kart.crush  && ! Drift.jump )
    rotate_kart();

  if( Kart.fall ) return;

  // htg
  if( Drift.inatia_speed )
    {
      Drift.inatia_speed_acc += -INATIA_FRIC;
      if( Drift.inatia_speed_acc < -MAX_INATIA_FRIC )
        Drift.inatia_speed_acc = -MAX_INATIA_FRIC;

      Drift.inatia_speed += Drift.inatia_speed_acc;
      if( Drift.inatia_speed < 0 )
        Drift.inatia_speed = 0;

      speed = Drift.inatia_speed >> SPEED_DIV;
      add_x = cos_tbl[ Drift.inatia_rad ] * speed;
      add_y = sin_tbl[ Drift.inatia_rad ] * speed;

      Kart.x += add_x; Kart.y += add_y;
      if( is_bound_block( Kart.x, Kart.y ) )
        {
          Kart.x -= add_x; Kart.y -= add_y;
          Drift.crush_check = true;
        }
    }

  // 
  Kart.speed += Kart.speed_acc;
  if( Kart.speed > Kart.max_speed )
    Kart.speed = Kart.max_speed;
  if( Kart.speed < 0 )
    Kart.speed = 0;

  // V[ghtgp
  Drift.short_speed += Kart.speed_acc;
  if( Drift.short_speed > MAX_DRIFT_SHORT_SPEED )
    Drift.short_speed = MAX_DRIFT_SHORT_SPEED;
  if( Drift.short_speed < 0 )
    Drift.short_speed = 0;

  // C
  if( Course.no == 3 || Course.no == 8 )
    Kart.speed_acc += -FRIC/2;
  else
    Kart.speed_acc += -FRIC;
  if( Kart.speed_acc < -MAX_SPEED_ACC )
    Kart.speed_acc = -MAX_SPEED_ACC;

  // ړ
  speed = Kart.speed >> SPEED_DIV;
  add_x = cos_tbl[ Kart.rad ] * speed;
  add_y = sin_tbl[ Kart.rad ] * speed;

  Kart.x += add_x; Kart.y += add_y;
  if( is_bound_block( Kart.x, Kart.y ) )
    {
      Kart.x -= add_x; Kart.y -= add_y;
      Drift.crush_check = true;
    }

  // ubN˕Ԃ
  if( Drift.crush_check )
    {
      Drift.crush_check = false;
      if( Drift.short_speed == MAX_DRIFT_SHORT_SPEED || Drift.on )
        set_spin();

      Kart.rad = (Kart.rad + RAD_90) & RAD_MAX; // E90
      // `FbN
      add_x = cos_tbl[ Kart.rad ] * speed;
      add_y = sin_tbl[ Kart.rad ] * speed;
      if( is_bound_block( Kart.x + add_x, Kart.y + add_y ) )
        Kart.rad = (Kart.rad + RAD_180) & RAD_MAX; // 90

      Kart.speed_acc = Drift.inatia_speed_acc = Drift.inatia_speed = 0;
      Kart.speed /= 2;
      Drift.short_speed /= 2;
      if( Kart.speed < BOUND_SPEED )
        Kart.speed = BOUND_SPEED;
      Drift.on = Drift.jump = false;
      Drift.end = 0;
      Kart.steer = Kart.steer_full = 0;
    }
}



// XeAO
static void
operate_steer( void )
{
  if( Key.single & Keyset.left && ! Goal.goal && ! Kart.fall && Kart.speed && ! Kart.crush && ! Spin.on )
    {
      Kart.chr = BMP_KART_L;
      Kart.anime = false;
      Kart.steer_full = -MAX_STEER;
      Kart.l_wait++;

      // htg
      Drift.right = false;
      if( ! Drift.on && Drift.left && Drift.count >= DRIFT_TIMING_MIN && Drift.count <= DRIFT_TIMING_MAX && Kart.speed >= Engine.middle_speed )
        {
          Kart.steer = -DRIFT_STEER;
          set_drift_long();
        }
      else if( ! Drift.on && Kart.l_wait > SHORT_DRIFT_START && Drift.short_speed == MAX_DRIFT_SHORT_SPEED )
        {
          Kart.steer = -DRIFT_SHORT_STEER;
          Drift.left = true;
          set_drift_short();
        }
      else if( ! Drift.on )
        {
          Drift.left = true;
          Drift.count = 0;
        }
    }
  else if( Key.single & Keyset.right && ! Goal.goal && ! Kart.fall && Kart.speed && ! Kart.crush && ! Spin.on )
    {
      Kart.chr = BMP_KART_R;
      Kart.anime = false;
      Kart.steer_full = MAX_STEER;
      Kart.r_wait++;

      // htg
      Drift.left = false;
      if( ! Drift.on && Drift.right && Drift.count >= DRIFT_TIMING_MIN && Drift.count <= DRIFT_TIMING_MAX && Kart.speed >= Engine.middle_speed )
        {
          Kart.steer = DRIFT_STEER;
          set_drift_long();
        }
      else if( ! Drift.on && Kart.r_wait > SHORT_DRIFT_START && Drift.short_speed == MAX_DRIFT_SHORT_SPEED )
        {
          Drift.right = true;
          Kart.steer = DRIFT_SHORT_STEER;
          set_drift_short();
        }
      else if( ! Drift.on )
        {
          Drift.right = true;
          Drift.count = 0;
        }
    }
  else
    {
      Kart.steer_full = 0;
      Kart.l_wait = Kart.r_wait = 0;
      if( Drift.on )
        {
          Drift.end = DRIFT_WAIT;
          Drift.count = 0;
        }
      if( Drift.on && Turbo.frame > TURBO_START  && ! Turbo.count ) // ~j^[{
        {
          Turbo.count = TURBO_FRAME_MAX; // ^[{Jn
          Kart.speed = Engine.turbo_speed;
          Kart.max_speed = Engine.turbo_speed;

          set_se( turbo );
        }
      Drift.on = Drift.jump = false;
    }
}



// htg
static void
set_drift_long( void )
{
  Drift.on = Drift.jump = true;
  Drift.jump_count = JUMP_FRAME;
  Drift.frame = 0;
  Drift.inatia_rad = Kart.rad;
  Drift.inatia_speed = Kart.speed+32;
  Drift.inatia_speed_acc = 0;
  Kart.speed = 1;
//  Kart.speed_acc /= 2;
}


static void
set_drift_short( void )
{
  Drift.on = true;
  Drift.jump = false;
  Drift.frame = 0;
  Drift.inatia_rad = Kart.rad;
  Drift.inatia_speed = Kart.speed / 2;
  Drift.inatia_speed_acc = 0;
  Kart.speed /= 2;
//  Kart.speed_acc /= 2;
}



// E
static void
rotate_kart( void )
{
  if( Drift.on )
    {
      if( ++Drift.frame > SPIN_START )
        set_spin();
    }
  Kart.rad = (Camera.rad + Kart.steer / STEER_DIV) & RAD_MAX;
  Camera.rad = Kart.rad;

  if( Kart.steer < -STEER_DIV )
    {
      if( ++Course.bg_pos > 160 )
        Course.bg_pos = 0;
    }
  else if( Kart.steer > STEER_DIV )
    {
      if( --Course.bg_pos < 0 )
        Course.bg_pos = 160;
    }
}



/************************************************
 *	XsZbg
 ***********************************************/
static void
set_spin( void )
{
  Drift.on = Drift.jump = false;

  Spin.on = true;
  Spin.frame = SPIN_FRAME;
  Spin.anime = 0;

  Kart.speed /= 2;
  Kart.speed_acc = 0;
  Drift.short_speed = 0;
  Drift.inatia_speed = Drift.inatia_speed_acc = 0;

  set_se( fall );
}



/************************************************
 *	D
 ***********************************************/
static void
spin_mud( void )
{
  UInt8 pixel;
  Coord x, y;


  x = Kart.x >> FIXBIT; y = Kart.y >> FIXBIT;

  pixel = 255;
  if( (UInt16) x < COURSE_WIDTH && (UInt16) y < COURSE_HEIGHT )
    {
      pixel = *( course_y_p[ y ] + x );
    }

  if( pixel == PIXEL_MUD && ! Mud.frame && ! Spin.on )
    {
      Mud.frame = MUD_FRAME;
      Mud.acc_count = MUD_ACC_COUNT;
    }

  if( Mud.frame )
    {
      // XsLZ
      if( Key.keep & Keyset.acc )
        {
          Mud.acc_count--;
          if( ! Mud.acc_count )
            {
              Mud.frame = 0;
              return;
            }
        }
      Mud.frame--;
      if( ! Mud.frame )
        set_spin();
    }
}



/************************************************
 *	R[XAEg@
 ***********************************************/
static void
fall_kart( void )
{
  Coord x, y;
  UInt8 pixel;


  if( Kart.fall ) return;

  x = Kart.x >> FIXBIT; y = Kart.y >> FIXBIT;

  if( (UInt16) x < COURSE_WIDTH && (UInt16) y < COURSE_HEIGHT )
    pixel = *( course_y_p[ y ] + x );
  else
    pixel = out[ Course.no ];


  if( pixel == FALL_COLOR1 || pixel == FALL_COLOR2 )
    {
      Kart.fall = true;
      Kart.speed = FALL_KART_ANIME;
      Kart.fall_frame = Ghost.frame;
      Kart.fall_count = FALL_RESTART; // ߂JEg

      // I^
      if( Owata.on )
        {
          set_owata();
        }
      set_se( fall );
    }
}



/************************************************
 *	R[XAEg@X^[g
 ***********************************************/
static void
restart_kart( void )
{
  GhostRecType *read = Ghost.work_p;


  if( ! Kart.fall || Kart.speed || Owata.on ) return;

  // ߂
  if( --Kart.fall_frame < 0 ) Kart.fall_frame = 0;

  Kart.x = (Int32) read[ Kart.fall_frame ].x << FIXBIT;
  Kart.y = (Int32) read[ Kart.fall_frame ].y << FIXBIT;
  Kart.rad = read[ Kart.fall_frame ].rad;
  Camera.rad = Kart.rad;

  Drift.short_speed = 0;
  Drift.inatia_speed = Drift.inatia_speed_acc = 0;
  Kart.speed = Kart.speed_acc = 0;
  Kart.steer = Kart.steer_full = 0;
  Drift.on = Drift.jump = false;
  Drift.end = 0;
  Spin.on = false;

  if( ! (--Kart.fall_count) )
    {
      Kart.fall = false;
      // set_se( countdown2 );
    }
}



/************************************************
 *	ubN˕Ԃ`FbN
 ***********************************************/
static Boolean
is_bound_block( Int32 kart_x, Int32 kart_y )
{
  static UInt8 block[][4] = {
    { 125, 122, 161, 217 },
    { 188, 187, 189, 217 },
    { 93, 91, 101, 217 },
    { 222, 220, 224, 217 },
    { 20, 22, 19, 217 },
    { 125, 122, 161, 217 },
    { 188, 187, 189, 217 },
    { 93, 91, 101, 217 },
    { 222, 220, 224, 217 },
    { 20, 22, 19, 217 } };
  Coord x, y;
  UInt8 pixel;


  x = kart_x >> FIXBIT; y = kart_y >> FIXBIT;

  pixel = 255;
  if( (UInt16) x < COURSE_WIDTH && (UInt16) y < COURSE_HEIGHT )
    {
      pixel = *( course_y_p[ y ] + x );
    }

  if( pixel == block[ Course.no ][0]
      || pixel == block[ Course.no ][1]
      || pixel == block[ Course.no ][2]
      || pixel == block[ Course.no ][3] )
    {
      Kart.crush = CRUSH_FRAME;
      Turbo.frame = Turbo.count = 0; // ^[{Zbg
      set_se( crush );

      // I^
      if( Owata.on )
        {
          set_owata();
        }
      return true;
    }

  return false;
}



static void
set_owata( void )
{
  Owata.smoke = false;
  Owata.smoke_wait = OWATA_SMOKE_WAIT;
  Owata.bomb_wait = BOMB_WAIT+SEC;
  Owata.over_y = 12;
  Game.state = GAME_OVER;
  set_se( fall );
}



/************************************************
 *	[3D`
 ***********************************************/
void
draw_3d_view( void )
{
  int i, j, view_x, view_y, geo_x, geo_y;
  int f, d;
  PointType *tbl = (PointType *) Geo.table_p[ (Camera.rad + 32) & TBL_RAD_MAX ];
  UInt8 *screen = (UInt8 *) Screen.back_p + (UInt16)BACK_WIDTH * (BG_HEIGHT+STATE_HEIGHT);
  UInt8 *field = Course.field_p;


  if( ((Camera.rad +32) & RAD_MAX) >= 64 )
    {
      f = -1; d = 1; // * -1
    }
  else
    {
      f = 0; d = 0;
    }

  view_x = Kart.x >> FIXBIT;
  view_y = ( Kart.y >> FIXBIT ) - (((MAP_HEIGHT-1) ^ f) + d);

  for( i = MAP_HEIGHT; i > 0; i-- )
    {
      for( j = MAP_WIDTH; j > 0; j-- )
        {
          geo_x = (((*tbl).x ^ f) + d) + view_x;
          geo_y = (((*tbl).y ^ f) + d) + view_y;
          tbl++;

          if( (UInt16) geo_x < COURSE_WIDTH && (UInt16) geo_y < COURSE_HEIGHT )
            {
              *screen = *( course_y_p[ geo_y ] + geo_x );
            }
          else
            {
              *screen = out[ Course.no ];
            }

          *( screen + 1                ) = *screen;
          *( screen + BACK_WIDTH       ) = *screen;
          *( screen + BACK_WIDTH + 1   ) = *screen;

          screen += X_ASPECT;
        }
      screen += BACK_WIDTH;
    }
}



/************************************************
 *	R[X}bv\
 ***********************************************/
void
draw_course_map( void )
{
  int i, j, x, course;
  int *map = CourseMap.read_p;
  UInt8 *read = (UInt8 *) Course.field_p;
  UInt8 *screen = (UInt8 *) Screen.back_p + ((80+16) * BACK_WIDTH) + COURSE_MAP_POS;


  course = Course.no;
  if( course >= 5 ) course -= 5;

  for( i = 0; i < (80/16); i++ )
    {
      for( j = 0; j < (160/16); j++ )
        {
          sprite( j<<4, (i<<4) +80, BMP_MAP_BG1 + course );
        }
    }

  for( i = 0; i < COURSE_MAP_H; i++ )
    {
      for( j = 0; j < COURSE_MAP_W; j++ )
        {
          x = *map++;
          if( x != -1 )
            {
              *screen = *( read + x );
            }
          screen++;
        }
      read += COURSE_WIDTH * COURSE_MAP_H_ASPECT;
    }
}



/************************************************
 *	R[X\
 ***********************************************/
void
print_course_name( void )
{
  if( Course.no < 5 )
    {
      sprite( 3, 83, Course.no + BMP_COURSE_NAME );
    }
  else
    {
      sprite( 3, 83, Course.no - 5 + BMP_COURSE_NAME );
      sprite( 70, 83, BMP_SECOND );
    }
}



/************************************************
 *	S[XgI\
 ***********************************************/
void
print_ghost_on( void )
{
  if( Ghost.on[ Course.no ] && Engine.cc == MODE_100CC )
    sprite( 122, 83, BMP_GHOST_ON );
}



/************************************************
 *	Q[[h\
 ***********************************************/
void
print_mode( void )
{
  if( Owata.on )
    sprite( 49, 49, BMP_OWATA_MODE );
  else
    sprite( 49, 49, BMP_NOMAL_MODE );
}


void
print_engine( void )
{
  switch( Engine.cc )
    {
    case 0:
      sprite( 101, 57, BMP_50CC );
      break;

    case 1:
      sprite( 101, 57, BMP_100CC );
      break;

    case 2:
      sprite( 101, 57, BMP_150CC );
      break;
    }
}



static void
print_record_time( void )
{
  UInt32 time, num;


  time = Rank.ranking[ Course.no ].time;
  // best
  sprite( 4, 2, BMP_RECORD_TIME );

  if( time == 0 )
    {
      sprite( 42, 2, BMP_NOENTRY );
      return;
    }

  // '
  sprite( 56, 2, BMP_SEP1 );
  // ''
  sprite( 78, 2, BMP_SEP2 );
  // 0
  show_num( 93, 2, 0, 1 );

  num = time;
  show_num( 85, 2, num, 1 );

  num = time / 10;
  num %= 60;
  show_num( 62, 2, num, 2 );

  num = time / 600;
  num %= 60;
  show_num( 42, 2, num, 2 );
}



void
clear_status( void )
{
  RectangleType r = { 0, 0, 160, 12 };


  WinSetDrawWindow( Screen.back_h );
  WinEraseRectangle( &r,0 );

  WinSetDrawWindow( 0 );
}

/************************************************
 *	R[X}[J[\
 ***********************************************/
static void
draw_marker( void )
{
  int i, xpos;
  Coord x, y;
  UInt8 *screen;
  Int32 w, rate = 717; // 0.7 * 1024 Œ菬_


  screen = (UInt8 *) Screen.back_p;

  x = Kart.x >> FIXBIT; y = Kart.y >> FIXBIT;
  if( (UInt16)x >= COURSE_WIDTH || (UInt16)y >= COURSE_HEIGHT ) return;

  y /= COURSE_MAP_H_ASPECT;
  w = COURSE_MAP_W * ( rate + y * 5 ); // 0.7 + y * 0.005
  xpos = BACK_WIDTH / 2 - (int) (w >> FIXBIT) / 2;
  x = ((( w / COURSE_MAP_W ) * (x / COURSE_MAP_W_ASPECT)) >> FIXBIT) + xpos;

  x -= 5; y += COURSE_MAP_POS_Y - 5;
  screen += ((UInt16)y << 7) + ((UInt16)y << 5) + x;

  // sNZҔ
  for( i = 0; i < MARK_SIZE_Y; i++ )
    {
      Marker.save[i][0] = *screen++;
      Marker.save[i][1] = *screen++;
      Marker.save[i][2] = *screen++;
      Marker.save[i][3] = *screen++;
      Marker.save[i][4] = *screen++;
      Marker.save[i][5] = *screen++;
      Marker.save[i][6] = *screen++;
      Marker.save[i][7] = *screen++;
      Marker.save[i][8] = *screen++;
      Marker.save[i][9] = *screen++;
      Marker.save[i][10] = *screen++;
      Marker.save[i][11] = *screen++;

      screen += BACK_WIDTH-MARK_SIZE_X;
    }
  sprite( x, y, BMP_MARKER );
}



/************************************************
 *	S[XgR[X}[J[\
 ***********************************************/
static void
draw_ghost_marker( void )
{
  int i, xpos;
  Coord x, y;
  GhostRecType *read = Ghost.read_p[ Course.no ];
  UInt8 *screen;
  Int32 w, rate = 717;


  if( !Ghost.on[ Course.no ] || Engine.cc != MODE_100CC ) return;

  x = read[ Ghost.frame ].x;
  y = read[ Ghost.frame ].y;
  if( x == -1 ) return;

  if( (UInt16)x >= COURSE_WIDTH || (UInt16)y >= COURSE_HEIGHT ) return;

  screen = (UInt8 *) Screen.back_p;

  y /= COURSE_MAP_H_ASPECT;
  w = COURSE_MAP_W * ( rate + y * 5 );
  xpos = BACK_WIDTH / 2 - (int) (w >> FIXBIT) / 2;
  x = ((( w / COURSE_MAP_W ) * (x / COURSE_MAP_W_ASPECT)) >> FIXBIT) + xpos;

  x -= 5; y += COURSE_MAP_POS_Y - 5;
  screen += ((UInt16)y << 7) + ((UInt16)y << 5) + x;

  for( i = 0; i < MARK_G_SIZE_Y; i++ )
    {
      GMarker.save[i][0] = *screen++;
      GMarker.save[i][1] = *screen++;
      GMarker.save[i][2] = *screen++;
      GMarker.save[i][3] = *screen++;
      GMarker.save[i][4] = *screen++;
      GMarker.save[i][5] = *screen++;
      GMarker.save[i][6] = *screen++;
      GMarker.save[i][7] = *screen++;
      GMarker.save[i][8] = *screen++;
      GMarker.save[i][9] = *screen++;
      GMarker.save[i][10] = *screen++;
      GMarker.save[i][11] = *screen++;

      screen += BACK_WIDTH - MARK_G_SIZE_X;
    }
  sprite( x, y, BMP_GHOST_MARKER );
}



/************************************************
 *	R[X}[J[
 ***********************************************/
static void
erase_marker( void )
{
  int i, xpos;
  Coord x, y;
  UInt8 *screen;
  Int32 w, rate = 717;


  screen = (UInt8 *) Screen.back_p;

  x = Kart.x >> FIXBIT; y = Kart.y >> FIXBIT;
  if( (UInt16)x >= COURSE_WIDTH || (UInt16)y >= COURSE_HEIGHT ) return;

  y /= COURSE_MAP_H_ASPECT;
  w = COURSE_MAP_W * ( rate + y * 5 );
  xpos = BACK_WIDTH / 2 - (int) (w >> FIXBIT) / 2;
  x = ((( w / COURSE_MAP_W ) * (x / COURSE_MAP_W_ASPECT)) >> FIXBIT) + xpos;

  x -= 5; y += COURSE_MAP_POS_Y - 5;
  screen += ((UInt16)y << 7) + ((UInt16)y << 5) + x;

  // sNZA
  for( i = 0; i < MARK_SIZE_Y; i++ )
    {
      *screen++ = Marker.save[i][0];
      *screen++ = Marker.save[i][1];
      *screen++ = Marker.save[i][2];
      *screen++ = Marker.save[i][3];
      *screen++ = Marker.save[i][4];
      *screen++ = Marker.save[i][5];
      *screen++ = Marker.save[i][6];
      *screen++ = Marker.save[i][7];
      *screen++ = Marker.save[i][8];
      *screen++ = Marker.save[i][9];
      *screen++ = Marker.save[i][10];
      *screen++ = Marker.save[i][11];

      screen += BACK_WIDTH - MARK_SIZE_X;
    }
}



/************************************************
 *	S[XgR[X}[J[
 ***********************************************/
static void
erase_ghost_marker( void )
{
  int i, xpos;
  Coord x, y;
  GhostRecType *read = Ghost.read_p[ Course.no ];
  UInt8 *screen;
  Int32 w, rate = 717;


  if( !Ghost.on[ Course.no ] || Engine.cc != MODE_100CC ) return;
  if( Ghost.frame )
    {
      x = read[ Ghost.frame-1 ].x;
      y = read[ Ghost.frame-1 ].y;
    }
  else
    {
      x = read[ Ghost.frame ].x;
      y = read[ Ghost.frame ].y;
    }
  if( x == -1 ) return;

  if( (UInt16)x >= COURSE_WIDTH || (UInt16)y >= COURSE_HEIGHT ) return;

  screen = (UInt8 *) Screen.back_p;

  y /= COURSE_MAP_H_ASPECT;
  w = COURSE_MAP_W * ( rate + y * 5 );
  xpos = BACK_WIDTH / 2 - (int) (w >> FIXBIT) / 2;
  x = ((( w / COURSE_MAP_W ) * (x / COURSE_MAP_W_ASPECT)) >> FIXBIT) + xpos;

  x -= 5; y += COURSE_MAP_POS_Y - 5;
  screen += ((UInt16)y << 7) + ((UInt16)y << 5) + x;

  for( i = 0; i < MARK_G_SIZE_Y; i++ )
    {
      *screen++ = GMarker.save[i][0];
      *screen++ = GMarker.save[i][1];
      *screen++ = GMarker.save[i][2];
      *screen++ = GMarker.save[i][3];
      *screen++ = GMarker.save[i][4];
      *screen++ = GMarker.save[i][5];
      *screen++ = GMarker.save[i][6];
      *screen++ = GMarker.save[i][7];
      *screen++ = GMarker.save[i][8];
      *screen++ = GMarker.save[i][9];
      *screen++ = GMarker.save[i][10];
      *screen++ = GMarker.save[i][11];

      screen += BACK_WIDTH - MARK_G_SIZE_X;
    }
}



/************************************************
 *	R[X쐬
 ***********************************************/
void
init_course( void )
{
  int i, j, course;
  UInt8 chr;
  UInt8 *read;


  read = BmpGetBits( WinGetBitmap( Bmp.handle[ Course.no + BMP_COURSE1_DATA ] ) );

  course = Course.no;
  if( course >= 5 ) course -= 5;

  // R[X`
  for( i = 0; i < COURSE_DATA_HEIGHT; i++ )
    {
      for( j = 0; j < COURSE_DATA_WIDTH; j++ )
        {
          chr = *read++;
          draw_course_chr( j * COURSE_CHR_WIDTH, i * COURSE_CHR_HEIGHT,
                           Bmp.handle[ (chr - 156) + BMP_COURSE_CHIP + course * 8 ] );
        }
    }

  // WvZpe[u
  for( i = 0; i < COURSE_HEIGHT; i++ )
    course_y_p[i] = Course.field_p + (Int32)i * COURSE_WIDTH;

  // D
  set_mud();
}



/************************************************
 *	R[XLN^`
 ***********************************************/
static void
draw_course_chr( UInt32 x, UInt32 y, WinHandle chr_no )
{
  int i, j, w, h;
  UInt8 *chr = BmpGetBits( WinGetBitmap( chr_no ) );
  UInt8 *field = (UInt8 *) Course.field_p + y * COURSE_WIDTH + x;


  w = COURSE_CHR_WIDTH; h = COURSE_CHR_HEIGHT;

  for( i = 0; i < h; i++ )
    {
      for( j = 0; j < w; j++ )
        {
          *field++ = *chr++;
        }
      field += (COURSE_WIDTH - w);
    }
}



static void
draw_mud_chr( UInt32 x, UInt32 y, WinHandle chr_no )
{
  int i, j, w, h;
  UInt8 *chr = BmpGetBits( WinGetBitmap( chr_no ) );
  UInt8 *field = (UInt8 *) Course.field_p + y * COURSE_WIDTH + x;


  w = COURSE_CHR_WIDTH+4; h = COURSE_CHR_HEIGHT+4;

  for( i = 0; i < h; i++ )
    {
      for( j = 0; j < w; j++ )
        {
          *field++ = *chr++;
        }
      field += (COURSE_WIDTH - w);
    }
}



/************************************************
 *	D`
 ***********************************************/
static void
set_mud( void )
{
  int i, r;
  Coord x, y;
  static int pos[ COURSE_MAX ][ MAX_MUD*2 ] = {
    { 12,4, 26,6, 35,9, 5,13, 2,21, 14,24, 26,19, 35,24 },
    { 0 },
    { 8,5, 25,5, 31,4, 32,9, 25,15, 34,20, 29,25, 17,26 },
    { 0 },
    { 0 },
    { 17,13, 36,5, 8,8, 1,14, 14,16, 29,14, 15,28, 36,24 },
    { 0 },
    { 12,2, 33,3, 1,11, 11,11, 23,17, 36,14, 8,24, 21,22 },
    { 0 },
    { 0 } };


  for( i = 0; i < MAX_MUD/2; i++ )
    {
      r = RND(8);
      x = pos[ Course.no ][ r*2 ] * 16;
      y = pos[ Course.no ][ r*2 +1 ] * 16;
      if( x != 0 && y != 0 )
        draw_course_chr( x, y, Bmp.handle[ BMP_MUD ] );
    }
}



/************************************************
 *	BG
 ***********************************************/
static void
init_bg( void )
{
  int course;


  course = Course.no;
  if( course >= 5 ) course -= 5;

  Course.bg_pos = 0;
  Course.bg_p = BmpGetBits( WinGetBitmap( Bmp.handle[ BMP_BG + course ] ) );
}



/************************************************
 *	BG`
 ***********************************************/
void
draw_bg( void )
{
  UInt8 *screen = (UInt8 *) Screen.back_p + (BACK_WIDTH * STATE_HEIGHT) + Course.bg_pos;
  UInt8 *chr = Course.bg_p;
  int i, j, w, h;


  w = BACK_WIDTH - Course.bg_pos;
  h = BG_HEIGHT;

  for( i = 0; i < h; i++ )
    {
      for( j = 0; j < w; j++ )
        {
          *screen++ = *chr++;
        }
      screen += Course.bg_pos;
      chr += Course.bg_pos;
    }


  if( ! Course.bg_pos ) return;

  screen = (UInt8 *) Screen.back_p + (BACK_WIDTH * STATE_HEIGHT);
  chr = Course.bg_p + BACK_WIDTH - Course.bg_pos;
  w = Course.bg_pos;

  for( i = 0; i < h; i++ )
    {
      for( j = 0; j < w; j++ )
        {
          *screen++ = *chr++;
        }
      screen += BACK_WIDTH - Course.bg_pos;
      chr += BACK_WIDTH - Course.bg_pos;
    }
}



