/******************************************************************************
 *
 *	PalmKart mini
 *	ver 1.3.3
 *	2008.11 / 2009.5
 *	ChoiKyun
 *
 *****************************************************************************/
#ifndef INCLUDED_GAME_H
#define INCLUDED_GAME_H


#ifdef GLOBAL_VALUE_DEFINE
#define GLOBAL
#define GLOBAL_VAL(v) = (v)
#else
#define GLOBAL extern
#define GLOBAL_VAL(v)
#endif



/************************************************
 *	萔
 ***********************************************/

// o[W
#define appFileCreator		'cK04'
#define appVersionNum		0x01
#define appPrefID		0x00
#define appPrefVersionNum	0x11

// f[^x[Xo[W
#define GEOMETRY_DB_VER 0x11
#define GHOST_DB_VER 0x11
#define COURSEMAP_DB_VER 0x11


// o[W
#define ourMinVersion	sysMakeROMVersion(2,0,0,sysROMStageRelease,0)
#define PalmRomVer300	sysMakeROMVersion(3,0,0,sysROMStageRelease,0)
#define PalmRomVer350	sysMakeROMVersion(3,5,0,sysROMStageRelease,0)

#define PalmRomVer500	sysMakeROMVersion(5,0,0,sysROMStageDevelopment,0) // CLIE΍

// J[
#define TRANS_COLOR 1

#define INDEX_WHITE 0
#define INDEX_BLACK 215

#define INDEX_GRAY 218
#define INDEX_CIAN 90
#define INDEX_MAGENTA 5
#define INDEX_RED 125


// FPS
//#define DEF_EVENT_TICK 6
#define SEC 20


// XRAl[
#define DEF_NAME_LEN 6


// Q[̐is
#define GAME_START 1
#define GAME_READY 2
#define GAME_FINISH 4
#define GAME_RESULT 8
#define GAME_TITLE 16
#define GAME_OVER 32


// n[hL[
#define keyBitRockerUp		  0x00010000  // 5-way rocker up
#define keyBitRockerDown	  0x00020000  // 5-way rocker down
#define keyBitRockerLeft	  0x00040000  // 5-way rocker left
#define keyBitRockerRight	  0x00080000  // 5-way rocker right
#define keyBitRockerCenter	  0x00100000  // 5-way rocker center/press

#define KEY_RIGHT keyBitHard3
#define KEY_LEFT keyBitHard2
#define KEY_UP keyBitPageUp
#define KEY_DOWN keyBitPageDown

#define KEY_1 keyBitHard1
#define KEY_2 keyBitHard2
#define KEY_3 keyBitHard3
#define KEY_4 keyBitHard4


// rbg}bv
#define BMP_BASE_ID 1000
#define MAX_BMP 133

#define BMP_TITLE 0

#define BMP_KART_NOMAL 1
#define BMP_KART_R 3
#define BMP_KART_L 4

#define BMP_COURSE1_DATA 5

#define BMP_50CC 16
#define BMP_100CC 17
#define BMP_150CC 18

#define BMP_KART_R_WAIT 19
#define BMP_KART_L_WAIT 20

#define BMP_MAX_SPEED 21

#define BMP_DRIFT_JUMP 23
#define BMP_DRIFT_CHR_R 24
#define BMP_DRIFT_CHR_L 25
#define BMP_DRIFT_R 26
#define BMP_DRIFT_L 27

#define BMP_SECOND 28

#define BMP_RECORD_TIME 29

#define BMP_BG 30

#define BMP_SMOKE 35

#define BMP_SE 36

#define BMP_LAP 38
#define BMP_TIME 39

#define BMP_PRE1 40
#define BMP_PRE2 41
#define BMP_PRE3 42
#define BMP_PRE4 43

#define BMP_MAP_BG1 44

#define BMP_NUM 49
#define BMP_SEP1 50
#define BMP_SEP2 51

#define BMP_MARKER 52

#define BMP_GOAL 53

#define BMP_TOTAL 54

#define BMP_COURSE_NAME 55

#define BMP_PUSH_KEY 60

#define BMP_GHOST1 61
#define BMP_GHOST2 62

#define BMP_GHOST_ON 63

#define BMP_GHOST_MARKER 64

#define BMP_BGM_SE 65

#define BMP_FALL_KART 69

#define BMP_TURBO 73

#define BMP_CRUSH 74

#define BMP_BOMB 75

#define BMP_NOMAL_MODE 79
#define BMP_OWATA_MODE 80

#define BMP_OVER 81

#define BMP_COURSE_CHIP 82

#define BMP_SPIN 122

#define BMP_MUD 126
#define BMP_MUD_SPRAY 127

#define BMP_NOENTRY 128

#define BMP_INC 129



// XRALO
#define MAX_RANKING 10
#define MAX_PAGE_RANKING 5


// obNXN[TCY
#define BACK_WIDTH 160
#define BACK_HEIGHT (160)

#define STATE_HEIGHT 12

//#define DOT_MAX 8


// XN[TCY
#define LCD_WIDTH 160
#define LCD_HEIGHT 160
// Q[EBhETCY
#define GAME_WIN_WIDTH 160
#define GAME_WIN_HEIGHT 160

#define MAP_WIDTH 80
#define MAP_HEIGHT 26

#define VIEW_HEIGHT 80 // ʕ\GA
#define X_ASPECT 2	// X,Y AXyNg
#define Y_ASPECT 2

#define ROTATE_CENTER_X 0 // ]_
#define ROTATE_CENTER_Y (MAP_HEIGHT-1)

#define COURSE_MAX 10
#define COURSE_DATA_WIDTH 40
#define COURSE_DATA_HEIGHT 30
#define COURSE_WIDTH 640
#define COURSE_HEIGHT 480

#define COURSE_CHR_WIDTH 16
#define COURSE_CHR_HEIGHT 16

#define BG_WIDTH 160
#define BG_HEIGHT 16

#define COURSE_MAP_W_ASPECT 4
#define COURSE_MAP_H_ASPECT 8
#define COURSE_MAP_W (COURSE_WIDTH / COURSE_MAP_W_ASPECT)
#define COURSE_MAP_H (COURSE_HEIGHT / COURSE_MAP_H_ASPECT)
#define COURSE_MAP_POS (BACK_WIDTH/2 - COURSE_MAP_W/2)
#define COURSE_MAP_POS_X (BACK_WIDTH/2 - COURSE_MAP_W/2)
#define COURSE_MAP_POS_Y 96



// ʉf[^
#define SND_LENGTH 30


// tHgTCY
#define NUM_WIDTH (6+1)
#define NUM_HEIGHT 8


// I[gp[It
#define AUTO_OFF_TIME (3*60)


// R[h
#define REC_MAX 64
#define REC_SIZE ( sizeof(PointType) * MAP_WIDTH * MAP_HEIGHT)


#define RAD_MAX 127
#define TBL_RAD_MAX 63
#define FIX 1024L
#define FIXBIT 10


////// e평l

// EFCg
#define MES_WAIT (SEC/2) //bZ[Wp


// f
#define DEMO_WAIT (1*SEC)


// @
#define SHIP_WIDTH 22
#define SHIP_HEIGHT 26
#define SHIP_X (BACK_WIDTH/2-SHIP_WIDTH/2)
#define SHIP_Y (VIEW_HEIGHT-SHIP_HEIGHT-2)

#define MODE_50CC 0
#define MODE_100CC 1
#define MODE_150CC 2

#define MAX_SPEED_50 (64*5)
#define MIDDLE_SPEED_50 (64*3)
#define TURBO_SPEED_50 (64*7)

#define MAX_SPEED_100 (64*6)
#define MIDDLE_SPEED_100 (64*4)
#define TURBO_SPEED_100 (64*8)

#define MAX_SPEED_150 (64*7)
#define MIDDLE_SPEED_150 (64*5)
#define TURBO_SPEED_150 (64*9)

#define MAX_DRIFT_SHORT_SPEED (64*20)

#define BOUND_SPEED (64*3)
#define MAX_SPEED_ACC 32
#define SPEED_DIV 6
#define ACC 4 // ANZ
#define FRIC 2 // C
#define BRAKE_ACC 32 // u[L

#define TURBO_START (12) // ^[{Jn܂
#define TURBO_FRAME_MAX 8 // ^[{t[

#define SMOKE_X (SHIP_X-2)
#define SMOKE_Y (VIEW_HEIGHT-11)

#define LAP_MAX 5
#define GOAL_LAP 6
#define GOAL_WAIT (4*SEC)

#define START_DASH 10

#define MARK_SIZE_X 12
#define MARK_SIZE_Y 12
#define MARK_G_SIZE_X 12
#define MARK_G_SIZE_Y 12

#define GHOST_MAX (180*SEC)
#define REC_GHOST_SIZE (180*SEC*sizeof(GhostRecType))
#define GHOST_SIZE_X 8
#define GHOST_SIZE_Y 8

#define BGM_MAX 2

#define BGM_OFF_SE_OFF 0
#define SE_ON 1
#define BGM_ON 2
#define BGM_ON_SE_ON 3

#define FALL_COLOR1 73
#define FALL_COLOR2 215
#define FALL_RESTART 12
#define FALL_ANIME_DIV 4
#define FALL_KART_ANIME (FALL_ANIME_DIV*4)
#define FALL_RES_MIN 2
#define FALL_RES_MAX 4

#define RAD_90 32
#define RAD_180 64

#define CRUSH_FRAME 12

#define JUMP_FRAME 3

#define MELODY_LENGTH 128

#define BOMB_WAIT 10
#define OWATA_SMOKE_WAIT 14

#define MAX_STEER (32*3)
#define STEER_DIV 32
#define STEER_SNAP 6

#define DRIFT_STEER MAX_STEER
#define DRIFT_SHORT_STEER (32*1)
#define DRIFT_TIMING_MIN 2
#define DRIFT_TIMING_MAX 4
#define DRIFT_WAIT 6
#define SHORT_DRIFT_START 8

#define INATIA_FRIC 1 // 
#define MAX_INATIA_FRIC 32

#define SPIN_FRAME (2*4*3)
#define SPIN_START (SEC+5)

#define MAX_MUD 8
#define MUD_FRAME 16
#define MUD_ACC_COUNT 2
#define PIXEL_MUD 167

#define DEMO_CHR_COUNT 12
//#define GOAL_CHR_COUNT 9



/************************************************
 *	}N
 ***********************************************/
// _
#define RND(N) ((((Int32) SysRandom (0)) * (N)) / ((Int32) sysRandomMax + 1))
// Xbv
#define SWAP(a,b)\
  a = a ^ b;\
  b = a ^ b;\
  a = a ^ b;


/************************************************
 *	錾
 ***********************************************/
// ʉԍ
typedef enum
{
  no_sound,	// Ȃ
  drift,
  maxspeed,
  rough,
  turbo,
  countdown1,
  countdown2,
  crush,
  fall,
  lap,
  goal,
  click,
  sound_cnt
} SoundType;



// Q[̐is
typedef struct
{
  UInt16 state;		// Q[istO
  Boolean active;
  Boolean pause;
} GameStateType;


// vC[
typedef struct
{
  UInt32 score;
} PlayerType;


// y
typedef struct
{
  Boolean down;			// ytO
  Boolean move;
  Coord x;			// yXW
  Coord y;			// yYW
} PenType;


// L[
typedef struct
{
  UInt32 single;		// L[P
  UInt32 keep;			// L[A
  Boolean first_center;		// dh~
} KeyType;


// ʃ[h̕ۑ
typedef struct
{
  UInt32 width;
  UInt32 height;
  UInt32 depth;
} ScreenModeType;


// XN[
typedef struct
{
  ScreenModeType save;		// ʃ[h
  WinHandle back_h;		// obNXN[nh
  void *back_p;			// obNXN[|C^
  void  *lcd_p;			// kbc|C^
  Boolean os5;
} ScreenType;


// rbg}bv
typedef struct
{
  WinHandle handle[ MAX_BMP+1 ];
  UInt8 * ptr[ MAX_BMP+1 ];
  PointType extent[ MAX_BMP+1 ];
} BmpType;


// ^C}[
typedef struct
{
  UInt32 interval;
  UInt16 frame_tick;
} TimerType;


// ʉ
typedef struct
{
  int on;			// ʉtO
  SoundType type;		// ʉԍ
  int count;
  UInt16 volume;		// {[
} SeType;


// Aj
typedef struct
{
  UInt16 counter;		// AjpJE^
} AnimeType;


// nCXRA
typedef struct
{
  char name[DEF_NAME_LEN+1];	// O
  UInt32 time;			// nCXRA
} HiScoreType;


// LO
typedef struct
{
  int course;
  int page;
  char last_name[ DEF_NAME_LEN+1 ];	// Ōɓ͂O
  HiScoreType ranking[ MAX_RANKING ];	// XRALO
} RankingType;


// Q[vt@@X
typedef struct
{
  RankingType rank;
  int sound;
  Boolean owata_on;
  int engine_cc;
} GamePrefType;


// bZ[W
typedef struct
{
  Int16 wait;
  Boolean se;
} MessageType;


// I[gp[It
typedef struct
{
  UInt16 seconds;
} AutoOffType;


// Wϊe[uf[^x[X
typedef struct
{
  DmOpenRef db_p;
  MemHandle save_h[ REC_MAX ];
  PointType* table_p[ REC_MAX ];
} GeometryTblType;


// J[g
typedef struct
{
  Boolean smoke;
  Boolean anime;
  Boolean fall;
  int crush;
  int fall_frame;
  int fall_count;
  int rad;
  int chr;
  int speed;
  int speed_acc;
  int max_speed;
  int steer;
  int steer_full;
  Int32 x;
  Int32 y;
  int r_wait;
  int l_wait;
  int shake_y;
} KartType;


// R[Xf[^
typedef struct
{
  int no;
  int bg_pos;
  IndexedColorType *field_p;
  UInt8 *bg_p;
  WinHandle field_h;
} CourseType;


// }[J[
typedef struct
{
  IndexedColorType save[MARK_SIZE_Y][MARK_SIZE_X];
} MarkerType;


// ^CJEg
typedef struct
{
  int count;
  UInt32 tick;
  UInt32 time[LAP_MAX+1];
  UInt32 total;
} LapType;


// `FbN
typedef struct
{
  Boolean through;	// ʉ߃tO
  int reverse;		// tJE^
} CheckGoalType;


//JEg_E
typedef struct
{
  Boolean c1;
  Boolean c2;
} CountDownType;


// S[
typedef struct
{
  Boolean goal;
  int frame_wait;
} GoalType;


// R[h\
typedef struct
{
  int lap1;
  int lap2;
  int lap3;
  int lap4;
  int lap5;
  int lap6;
} RecType;


// demo
typedef struct
{
  int rad;
  int chr;
  int chr_count;
  int ind_count;
  int ind_y;
  Boolean end;
} DemoType;


// PbgX^[g
typedef struct
{
  Boolean on;
} DashType;


// L[vZbg
typedef struct
{
  UInt32 right;
  UInt32 left;
  UInt32 up;
  UInt32 center;
  UInt32 acc;
  UInt32 brake;
} KeySetType;


// S[XgR[h
typedef struct
{
  Coord x;
  Coord y;
  int rad;
} GhostRecType;


// S[Xg
typedef struct
{
  int frame;
  Boolean on[ COURSE_MAX ]; // S[XgON
  DmOpenRef db_p;
  MemHandle read_h[COURSE_MAX];
  GhostRecType *read_p[COURSE_MAX];
  GhostRecType *work_p;
  IndexedColorType save[GHOST_SIZE_Y][GHOST_SIZE_X];
} GhostType;


// BGM
typedef struct
{
  Boolean on;
  int no;
  int frame;
  int count;
  UInt16 volume;
} BgmStateType;

// ^[{
typedef struct
{
  int frame;
  int count;
} TurboType;

// J
typedef struct
{
  int rad;
} CameraType;

// R[X}bv
typedef struct
{
  DmOpenRef db_p;
  MemHandle read_h;
  int *read_p;
} CourseMapType;

// I^
typedef struct
{
  Boolean on;
  Boolean smoke;
  int bomb_wait;
  int smoke_wait;
  int over_y;
} OwataType;

// htg
typedef struct
{
  Boolean on;
  Boolean jump;
  Boolean right;
  Boolean left;
  int count;
  int jump_count;
  int frame;
  int end;
  int short_speed;
  int inatia_rad;
  int inatia_speed; // htg
  int inatia_speed_acc;
  Boolean crush_check;
} DriftType;

// GW
typedef struct
{
  int cc;
  int max_speed;
  int middle_speed;
  int turbo_speed;
} EngineType;

// Xs
typedef struct
{
  Boolean on;
  int frame;
  int anime;
} SpinType;

// D
typedef struct
{
  int frame;
  int acc_count;
} MudType;



/************************************************
 *	O[oϐ
 ***********************************************/
GLOBAL GameStateType Game;
GLOBAL PlayerType Player;
GLOBAL PenType Pen;
GLOBAL KeyType Key;
GLOBAL ScreenType Screen;
GLOBAL BmpType Bmp;
GLOBAL TimerType Timer;
GLOBAL SeType Sound;
GLOBAL AnimeType Anime;
GLOBAL RankingType Rank;
GLOBAL MessageType Message;
GLOBAL AutoOffType AutoOff;

GLOBAL GeometryTblType Geo;
GLOBAL KartType Kart;
GLOBAL CourseType Course;
GLOBAL MarkerType Marker;
GLOBAL MarkerType GMarker;
GLOBAL LapType Lap;
GLOBAL CheckGoalType CheckGoal;
GLOBAL CountDownType Count;
GLOBAL GoalType Goal;
GLOBAL RecType Rec_wait;
GLOBAL DemoType Demo;
GLOBAL DashType Dash;
GLOBAL KeySetType Keyset;
GLOBAL GhostType Ghost;
GLOBAL TurboType Turbo;
GLOBAL BgmStateType Bgm;
GLOBAL CameraType Camera;
GLOBAL CourseMapType CourseMap;
GLOBAL OwataType Owata;
GLOBAL DriftType Drift;
GLOBAL EngineType Engine;
GLOBAL SpinType Spin;
GLOBAL MudType Mud;



/************************************************
 *	vg^Cv
 ***********************************************/
// starter.c
UInt32 PilotMain( UInt16, MemPtr, UInt16 );
void get_hard_key( void );		// n[hL[擾



// game.c
void init_game( void );
void play_game( void );			// Q[C
void pre_start( void );
void select_course( void );
void init_course( void );
void init_engine( void );
void change_engine( void );
void draw_course_map( void );
void print_course_name( void );
void print_ghost_on( void );
void draw_3d_view( void );
void draw_kart( void );
void draw_bg( void );
void clear_status( void );



// graphic.c
Err init_screen( void );		// XN[
void clear_screen( void );		// SʃNAiobNXN[j
void copy_buff_to_lcd( void );		// LCD]
void sprite( Coord, Coord, int );	// LN^`
void sprite_num( Coord, Coord, int );
void clear_view( void );


// sound.c
void change_se( void );			// ʉ؂ւ
void set_se( SoundType );		// ʉZbg
void play_se( void );			// ʉ



// score.c
void init_hiscore( void );		// nCXRA
void check_hiscore( UInt32 );		// nCXRAXV
void show_ranking( void );		// LO\
void show_num( Coord, Coord, UInt16, int );	// l\



// message.c
Boolean select_game_event( void );	// e탁bZ[W
void show_status( void );		// Xe[^X\
void disp_se( void );		// ACR\
void show_title( void );
void disp_total_record( void );
Boolean input_anykey( void );



// sin.c



// database.c
Err open_geometry_db( void );
Err open_ghost_db( void );
Err open_coursemap_db( void );
Err write_ghost_record( void );
void close_geometry_db( void );
void close_ghost_db( void );
void close_coursemap_db( void );
void delete_ghost_db( void );



// melody
void melody( void );
void init_bgm( void );
void play_bgm( void );




#undef GLOBAL
#undef GLOBAL_VAL



#endif // INCLUDED_GAME_H
