/******************************************************************************
 *
 *	PalmKart mini
 *	ver 1.3.3
 *	2008.11 / 2009.5
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <SonyCLIE.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
void play_tone( int );



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/

// yȃf[^
static int melody_data[ BGM_MAX ][ MELODY_LENGTH ] = {
  { -1 },
  { -1 },
};



// K
static int tone[25] = {
  0, // x
  262, 277, 294, 311, 330, 349, 370, 392, 415, 440, 466, 494, // oct3
  523, 554, 587, 622, 659, 698, 740, 784, 831, 880, 932, 988  // oct4
  };



// f[^it[Pʁj [S] [] [l] [] [\Z]
static int note_data[5] = { 32, 16, 8, 4, 2 };



/************************************************
 *	fB[ BGM, ʉ
 ***********************************************/
void
melody( void )
{
  if( ! Sound.on || ! Game.active ) return;

  if( Sound.on & SE_ON )
    {
      play_se();
    }

  if( Sound.on & BGM_ON && Bgm.on )
    {
      play_bgm();
    }
}



/************************************************
 *	BGM
 ***********************************************/
void
init_bgm( void )
{
  Bgm.no = 0;
  Bgm.on = false;
  Bgm.count = 0;
  Bgm.frame = 0;
  Bgm.volume = PrefGetPreference( prefGameSoundVolume ) -16;

  Sound.type = no_sound;
}



/************************************************
 *	BGMĐ t[P
 ***********************************************/
void
play_bgm( void )
{
  int melody;


  if( Bgm.frame == 0 )
    {
      melody = melody_data[Bgm.no][ Bgm.count ] / 10;
      Bgm.frame = note_data[ melody_data[Bgm.no][ Bgm.count ] % 10 ];
    }

  if( Sound.type == no_sound )
    {
      play_tone( tone[ melody ] );
    }

  Bgm.frame--;
  Bgm.count++;
  if( melody_data[Bgm.no][ Bgm.count ] == -1 )
    Bgm.count = 0;
}



static void
play_tone( int tone )
{
  SndCommandType s;


  s.cmd = sndCmdFrqOn;
  s.param1 = tone;
  s.param2 = 60;
  s.param3 = Bgm.volume;

  SndDoCmd( NULL, &s, true );
}



